#include "engine/platform/platform.h"

// #include <limits.h>
// #include <stdio.h>
// #include <cstring>
// #include <memory>
//
#include "base/log.h"
// #include "base/vecmath.h"
// #include "engine/input_event.h"
// #include "engine/platform/platform_observer.h"

using namespace base;

namespace eng {

void KaliberMain(Platform* platform);

Platform::Platform(HINSTANCE hInstance, int nCmdShow) : hInst(hInstance) {
  LOG(0) << "Initializing platform.";

  root_path_ = "./";
  data_path_ = "./";
  shared_data_path_ = "./";

  LOG(0) << "Root path: " << root_path_.c_str();
  LOG(0) << "Data path: " << data_path_.c_str();
  LOG(0) << "Shared data path: " << shared_data_path_.c_str();

  WNDCLASSEXW wcex;
  wcex.cbSize = sizeof(WNDCLASSEX);
  wcex.style = CS_HREDRAW | CS_VREDRAW;
  wcex.lpfnWndProc = WndProc;
  wcex.cbClsExtra = 0;
  wcex.cbWndExtra = 0;
  wcex.hInstance = hInstance;
  wcex.hIcon =
      nullptr;  // LoadIcon(hInstance, MAKEINTRESOURCE(IDI_WINDOWSPROJECT1));
  wcex.hCursor = LoadCursor(nullptr, IDC_ARROW);
  wcex.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  wcex.lpszMenuName = nullptr;  // MAKEINTRESOURCEW(IDC_WINDOWSPROJECT1);
  wcex.lpszClassName = L"szWindowClass";
  wcex.hIconSm =
      nullptr;  // LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));
  RegisterClassExW(&wcex);

  hWnd = CreateWindowW(L"szWindowClass", L"kaliber", WS_OVERLAPPEDWINDOW,
                       CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, nullptr, nullptr,
                       hInstance, nullptr);
  CHECK(hWnd);

  ShowWindow(hWnd, nCmdShow);
  UpdateWindow(hWnd);
}

Platform::~Platform() {
  LOG(0) << "Shutting down platform.";
}

void Platform::Update() {}

void Platform::Exit() {
  should_exit_ = true;
}

void Platform::Vibrate(int duration) {}

void Platform::ShowInterstitialAd() {}

void Platform::ShareFile(const std::string& file_name) {}

void Platform::SetKeepScreenOn(bool keep_screen_on) {}

HINSTANCE Platform::GetInstance() {
  return hInst;
}

HWND Platform::GetWindow() {
  return hWnd;
}

LRESULT CALLBACK Platform::WndProc(HWND hWnd,
                                   UINT message,
                                   WPARAM wParam,
                                   LPARAM lParam) {
  // switch (message)
  // {
  // case WM_COMMAND:
  //     {
  //         int wmId = LOWORD(wParam);
  //         // Parse the menu selections:
  //         switch (wmId)
  //         {
  //         case IDM_ABOUT:
  //             DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
  //             break;
  //         case IDM_EXIT:
  //             DestroyWindow(hWnd);
  //             break;
  //         default:
  //             return DefWindowProc(hWnd, message, wParam, lParam);
  //         }
  //     }
  //     break;
  // case WM_PAINT:
  //     {
  //         PAINTSTRUCT ps;
  //         HDC hdc = BeginPaint(hWnd, &ps);
  //         // TODO: Add any drawing code that uses hdc here...
  //         EndPaint(hWnd, &ps);
  //     }
  //     break;
  // case WM_DESTROY:
  //     PostQuitMessage(0);
  //     break;
  // default:
      return DefWindowProc(hWnd, message, wParam, lParam);
  // }
  // return 0;
}

}  // namespace eng

int APIENTRY wWinMain(_In_ HINSTANCE hInstance,
                      _In_opt_ HINSTANCE hPrevInstance,
                      _In_ LPWSTR lpCmdLine,
                      _In_ int nCmdShow) {
  eng::Platform platform(hInstance, nCmdShow);
  eng::KaliberMain(&platform);
  return 0;
}
